# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetVpcResult',
    'AwaitableGetVpcResult',
    'get_vpc',
    'get_vpc_output',
]

@pulumi.output_type
class GetVpcResult:
    """
    A collection of values returned by getVpc.
    """
    def __init__(__self__, api_version=None, id=None, metadata=None, specs=None, statuses=None, vpc_name=None, vpc_uuid=None):
        if api_version and not isinstance(api_version, str):
            raise TypeError("Expected argument 'api_version' to be a str")
        pulumi.set(__self__, "api_version", api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if specs and not isinstance(specs, list):
            raise TypeError("Expected argument 'specs' to be a list")
        pulumi.set(__self__, "specs", specs)
        if statuses and not isinstance(statuses, list):
            raise TypeError("Expected argument 'statuses' to be a list")
        pulumi.set(__self__, "statuses", statuses)
        if vpc_name and not isinstance(vpc_name, str):
            raise TypeError("Expected argument 'vpc_name' to be a str")
        pulumi.set(__self__, "vpc_name", vpc_name)
        if vpc_uuid and not isinstance(vpc_uuid, str):
            raise TypeError("Expected argument 'vpc_uuid' to be a str")
        pulumi.set(__self__, "vpc_uuid", vpc_uuid)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> str:
        """
        The version of the API.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def metadata(self) -> Mapping[str, str]:
        """
        - The vpc kind metadata.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def specs(self) -> Sequence['outputs.GetVpcSpecResult']:
        """
        VPC input spec
        """
        return pulumi.get(self, "specs")

    @property
    @pulumi.getter
    def statuses(self) -> Sequence['outputs.GetVpcStatusResult']:
        """
        VPC output status
        """
        return pulumi.get(self, "statuses")

    @property
    @pulumi.getter(name="vpcName")
    def vpc_name(self) -> Optional[str]:
        return pulumi.get(self, "vpc_name")

    @property
    @pulumi.getter(name="vpcUuid")
    def vpc_uuid(self) -> Optional[str]:
        return pulumi.get(self, "vpc_uuid")


class AwaitableGetVpcResult(GetVpcResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVpcResult(
            api_version=self.api_version,
            id=self.id,
            metadata=self.metadata,
            specs=self.specs,
            statuses=self.statuses,
            vpc_name=self.vpc_name,
            vpc_uuid=self.vpc_uuid)


def get_vpc(vpc_name: Optional[str] = None,
            vpc_uuid: Optional[str] = None,
            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVpcResult:
    """
    Provides a datasource to retrieve VPC with vpc_uuid or vpc_name .


    :param str vpc_name: vpc Name
    :param str vpc_uuid: vpc UUID
    """
    __args__ = dict()
    __args__['vpcName'] = vpc_name
    __args__['vpcUuid'] = vpc_uuid
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getVpc:getVpc', __args__, opts=opts, typ=GetVpcResult).value

    return AwaitableGetVpcResult(
        api_version=pulumi.get(__ret__, 'api_version'),
        id=pulumi.get(__ret__, 'id'),
        metadata=pulumi.get(__ret__, 'metadata'),
        specs=pulumi.get(__ret__, 'specs'),
        statuses=pulumi.get(__ret__, 'statuses'),
        vpc_name=pulumi.get(__ret__, 'vpc_name'),
        vpc_uuid=pulumi.get(__ret__, 'vpc_uuid'))
def get_vpc_output(vpc_name: Optional[pulumi.Input[Optional[str]]] = None,
                   vpc_uuid: Optional[pulumi.Input[Optional[str]]] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetVpcResult]:
    """
    Provides a datasource to retrieve VPC with vpc_uuid or vpc_name .


    :param str vpc_name: vpc Name
    :param str vpc_uuid: vpc UUID
    """
    __args__ = dict()
    __args__['vpcName'] = vpc_name
    __args__['vpcUuid'] = vpc_uuid
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getVpc:getVpc', __args__, opts=opts, typ=GetVpcResult)
    return __ret__.apply(lambda __response__: GetVpcResult(
        api_version=pulumi.get(__response__, 'api_version'),
        id=pulumi.get(__response__, 'id'),
        metadata=pulumi.get(__response__, 'metadata'),
        specs=pulumi.get(__response__, 'specs'),
        statuses=pulumi.get(__response__, 'statuses'),
        vpc_name=pulumi.get(__response__, 'vpc_name'),
        vpc_uuid=pulumi.get(__response__, 'vpc_uuid')))
